require({cache:{
'url:sas-cpb/datagrid/multigrid/MultiGridTemplate.html':"<div style='width:100%'>\n\n   <div data-dojo-type='dijit/layout/ContentPane'\n         data-dojo-attach-point='topPanel'\n         data-dojo-props='region:\"top\"'>\n      <div data-dojo-attach-point='gridTitle' class='dataGridTitle'></div>\n      <div data-dojo-attach-point='toolbar' style='display:none'></div>\n   </div>\n   \n   <div data-dojo-type='dijit/layout/ContentPane'\n         data-dojo-attach-point='centerPanel'\n         data-dojo-props='region:\"center\", splitter:true'>\n      <div data-dojo-attach-point='gridContainer'></div>\n   </div>\n    \n   <div data-dojo-type='dijit/layout/ContentPane'\n         data-dojo-attach-point='sidePanel'\n         data-dojo-props='region:\"${detailsPanelRegion}\", splitter:true, minSize:${detailsPaneMinSize}'>\n      <div data-dojo-type='dijit/TitlePane' data-dojo-props='toggleable:false, title:\"${detailsSectionTitle}\"'\n            data-dojo-attach-point='detailsPanel' style='width:${detailsPaneMinSize}px; padding:0 !important'\n            class='multiGridDetailsPanel'>\n      </div>\n   </div>\n    \n</div>"}});
/**
 * A composite component that can contain multiple grids in a tab container,
 * along with another panel docked on the right that can be used to display
 * information about the selected row.
 */
define("sas-cpb/datagrid/multigrid/MultiGrid", ['sas-cpb/cpb', 'sas-cpb/datagrid/CPBGridUtil', 'sas-cpb/util/NLSUtil', 'sas-cpb/util/TemplatedDijitUtil',
      'dojo/_base/declare', 'dojo/_base/lang', 'dojo/_base/array',
      'dojo/aspect', 'dojo/dom-style', 'dojo/dom-geometry', 'dojo/query',
      'dijit/layout/TabContainer',
      'dijit/layout/ContentPane',
      'dijit/layout/BorderContainer',
      'dijit/_TemplatedMixin',
      'dijit/_WidgetsInTemplateMixin',
      'dojo/text!./MultiGridTemplate.html',
      'dojo/i18n!./nls/MultiGrid',
      // Used in template
      'dijit/TitlePane',
      'xstyle/css!./MultiGrid.css'],
   function(cpb, CPBGridUtil, NLSUtil, TemplatedDijitUtil,
         declare, lang, array, aspect, domStyle, domGeom, query,
         TabContainer, ContentPane,
         BorderContainer, _TemplatedMixin, _WidgetsInTemplateMixin, _template, resources) {
   
var MultiGrid = declare('MultiGrid', [BorderContainer, _TemplatedMixin, _WidgetsInTemplateMixin], {
   
   title: null,
   templateString: _template,
   design: 'sidebar',
   gutters: false,
   liveSplitters: true,
   
   // Ugh.  Used to only allow _sizeToFitContent() to be called recursively twice.
   _sizeToFitContentCount: 0,
   
   detailsSectionTitle: null,
   detailsPaneMinSize: null,
   detailsPaneHidden: false,
   detailsPanelRegion: 'trailing',
   _singleGrid: false,
   _fixedHeight: null,
   _params: null,
   _toolbar: null,
   _tabContainer: null,
   _activeGrid: null,
   _cpbName: null,
   _cpbStoreName: null,
   _childGrids: null,
   
   constructor: function(args) {
      this._readOnly = args.readOnly || false;
      this._uiContextId = args.uiContextId;
      this._cpbName = args.name;
      if (args.name) {
         this.id = args.name;
      }
      this._cpbStoreName = args.storeName;
      this._printMode = args.printMode;
      this._singleGrid = args.printMode || (args.params && args.params.singleGrid) || false;
      this._fixedHeight = (args.params && args.params.height) || null;
      this.detailsPaneMinSize = (args.params && args.params.detailsPaneMinSize) || 300; // in pixels
      this.detailsPaneHidden = args.printMode || (args.params && args.params.detailsPaneHidden) || false;
      this.detailsPanelRegion = (args.params && args.params.detailsPanelRegion) || this.detailsPanelRegion;
      this._params = args.params || {};
      this.set('detailsSectionTitle', TemplatedDijitUtil.escapeAllQuotesForHtmlAttribute(
            args.params && args.params.detailsSectionTitle ?
            args.params.detailsSectionTitle : NLSUtil.resolve('detailsSection_default_header_txt', resources)));
   },
   
   buildRendering: function() {
      this.inherited(arguments);
   },
   
   postCreate: function() {
      if (this._fixedHeight) {
         domStyle.set(this.domNode, 'height', this._fixedHeight);
      }
      this.inherited(arguments);
      if (!this._readOnly) {
         this._toolbar = this.createToolbar();
      }
      if (!this._singleGrid) {
         this._addGridContainer();
      }
      
      // On resize events, resize the details panel appropriately.  Can't do this
      // in _sizeToFitContent() since that's not called if _fixedHeight===true
      var contentOuterPane = query('.dijitTitlePaneContentOuter', this.detailsPanel.domNode)[0];
      var that = this;
      aspect.after(this.detailsPanel, 'resize', function() {
         var h = domStyle.get(that.detailsPanel.domNode, 'height');
         var titlePaneTitle = that.detailsPanel.titleBarNode;
         h -= domStyle.get(titlePaneTitle, 'height');
         domStyle.set(contentOuterPane, { height: h + 'px', overflow: 'auto' });
      });
      
      if (this.detailsPaneHidden) {
         this.removeChild(this.sidePanel);
      }

      this.set('title', this._title); // Hack to get it to actually display
   },
   
   _addGridContainer: function() {
      
      this._childGrids = [];
      
      this._tabContainer = new TabContainer({
         id: this.get('cpbName') + '_tabContainer', // For Selenium
         //nested: true,
         style: 'height: 100%;'
      });
      this._tabContainer.placeAt(this.centerPanel);
      this._tabContainer.startup();
      
      var that = this;
      this._tabContainer.watch('selectedChildWidget', function(property, lastSelectedTab, newSelectedTab) {
         that._activeGrid = cpb.getGridsInElement(newSelectedTab.domNode)[0];
         //that._activeGrid.resize(); // Argh - needed the first time non-visible grids are displayed
         lang.hitch(that, that._sizeToFitContent)();
         that._refreshActions();
         that.refreshDetailsPanel();
      });
   },
   
   // summary:
   //    Ugh.  We're a BorderContainer, but we want to always fit our content vertically.  To do this, we listen
   //    for the grid's resize events, and programmatically determine our desired height to fit it just right.
   //    Unfortunately, us resizing ourselves causes the dgrid to re-resize itself, and what's worse is that it
   //    can actually resize itself to a *different* height that what it came up with the first time, even though
   //    we're sizing "just right" for it.  So to counteract this, we allow this method to be called recursively,
   //    but just 1 level deep.
   _sizeToFitContent: function() {
      
      if (this._fixedHeight) {
         return;
      }
      // Ugh.  Prevent infinite loop => we resize grid, which resizes us, etc.
      if (this._sizeToFitContentCount===2) {
         return;
      }
      this._sizeToFitContentCount++;
      
      // Compute our desired height based height of grid, its toolbar, and misc. padding.
      // The trick here is to fetch the grid's full, "preferred" height, not its actual height
      var toolbarH = domGeom.position(this.topPanel.domNode).h;
      var splitterH = 0;//domGeom.position(query('.dijitGutterH', this.domNode)[0]).h; // 0 since gutters===false
      var tabAreaH = this._singleGrid ? 0 : domGeom.position(query('.nowrapTabStrip', this._tabContainer.domNode)[0]).h;
      var wrapperCP1Spacing = 0;
      if (!this._singleGrid) {
         var wrapperCPs = query('.dijitTabContainerTop-child'/*'.dijitTabContainerTop-child.dijitVisible'*/);
         if (wrapperCPs && wrapperCPs.length>0) {
            var wrapperCP1 = wrapperCPs[0];
            wrapperCP1Spacing = domStyle.get(wrapperCP1, 'padding-top') + domStyle.get(wrapperCP1, 'padding-bottom');
            wrapperCP1Spacing += domStyle.get(wrapperCP1, 'margin-top') + domStyle.get(wrapperCP1, 'margin-bottom');
         }
      }
      var activeGridH = this._activeGrid ? domGeom.position(this._activeGrid.domNode).h : 0;
      this.domNode.style.height = (toolbarH + splitterH + tabAreaH + wrapperCP1Spacing + activeGridH) + 'px';
      
      this.resize();
      this._sizeToFitContentCount--;
      
   },
   
   _refreshActions: function() {
      
      if (!this._activeGrid || !this._toolbar) {
         return;
      }
      
      var selection = this._activeGrid.selection;
      var hasSelection = Object.getOwnPropertyNames(selection).length > 0;
      
      var children = this._toolbar.getChildren();
      for (var i = 0; i < children.length; i++) {
         if (children[i].sas_selectionButton) {
            children[i].set('disabled', !hasSelection);
         }
      }
      
   },
   
   // summary:
   //    Refreshes the content of the details panel.  Called in response to the active grid or selection
   //    changing.  Subclasses can override to show relevant information.
   refreshDetailsPanel: function() {
      this.detailsPanel.set('content', ''); // Content is always grid-specific
   },
   
   addGrid: function(tabTitle, /*sas-cpb/datagrid/ActionableGrid*/grid) {
      
      // "grid" is an instance of ActionableGrid.  Get the dgrid from the composite component
      var realGrid = grid.get('grid');
      this._addListeners(realGrid);
      
      if (this._singleGrid) { // No tabs
         this.centerPanel.destroyDescendants(false);
         this.centerPanel.addChild(grid);
         this._activeGrid = realGrid;
         this._activeGrid.resize(); // Argh - needed the first time non-visible grids are displayed
         this._refreshActions();
         this.refreshDetailsPanel();
      }
      else { // Tabs
         var cp = new ContentPane({
            id: realGrid.cpb_id + '_contentPane', // For Selenium
            title: tabTitle,
            content: grid,
            style: 'overflow: hidden'
         });
         this._tabContainer.addChild(cp);
         cp.startup();
         this._childGrids.push(grid);
      }

      // If this component should have a fixed height, force all dgrids to have
      // scroll bars and otherwise look good in that scenario
      if (this._fixedHeight) {
         var scroller = query('.dgrid-scroller', grid.domNode)[0];
         domStyle.set(scroller, { position: 'absolute', overflow: 'auto' });
         domStyle.set(realGrid.domNode, {
            position: 'absolute', top: '0px', bottom: '0px', left: '0px', right: '0px'
         });
      }
      
   },
   
   _addListeners: function(realGrid) {
      
      var that = this;
      
      if (!this._printMode) {
         // When active grid's selection changes, update grid-level actions
         var selectionChangedHandler = function(e) {
            that._refreshActions();
            that.refreshDetailsPanel();
         };
         realGrid.on('dgrid-select', selectionChangedHandler);
         realGrid.on('dgrid-deselect', selectionChangedHandler);
      }
      
      // When grid is resized (paging, loading, adding, deleting, etc.), resize us
      if (!that._fixedHeight) {
         aspect.after(realGrid, 'resize', function(results) {
            that._sizeToFitContent();
         });
         aspect.after(realGrid, 'renderArray', function(results) {
            if (typeof results.total === 'number') {
               realGrid.resize();
            }
            else {
               results.total.then(function(results) {
                  setTimeout(function() { realGrid.resize(); }, 1);
               });
            }
         }, true);
      }
      
      // Keep page size options for all grids in sync
      if (!that._singleGrid) {
         // NOTE: DijitRegistry doesn't support watch() unfortunately, so we aspect on the setter
         aspect.after(realGrid, '_setRowsPerPage', function(rowsPerPage) {
            if (that._updatingRowsPerPages) {
               return;
            }
            that._updatingRowsPerPages = true;
            array.forEach(that._childGrids, function(childGrid) {
               var dgrid = childGrid.get('grid');
               if (dgrid!==realGrid) {
                  dgrid.set('rowsPerPage', rowsPerPage);
               }
            }, that);
            that._updatingRowsPerPages = false;
         }, true);
      }
      
   },
   
   // summary:
   //    Subclasses can override to create a toolbar to operate on grid data.
   createToolbar: function() {
      return null;
   },

   // summary:
   //   Delegates the call to the currently active grid.
   cpb_getSelectedRowValues: function(colName) {
      return this._activeGrid.cpb_getSelectedRowValues(colName);
   },

   // summary:
   //   The message to display in the Details panel when no row is selected in a grid.
   //   Subclasses can override.
   getNoSelectionMessage: function() {
      return NLSUtil.resolve('noSelection_message_txt', resources);
   },
   
   // summary:
   //    Returns a localized string specific to this grid.  AppProperties is searched
   //    for a key of form "formattedGridName.keySuffix".
   getString: function(keySuffix) {
      var key = this.get('formattedCpbName') + '.' + keySuffix;
      var args = [ key, AppProperties ];
      for (var i=1; i<arguments.length; i++) {
         args.push(arguments[i]);
      }
      return NLSUtil.resolve.apply(this, args);
   },
   
   getParam: function(name) {
      return this._params[name];
   },
   
   // Getters and setters
   _getActiveGridAttr: function() {
      return this._activeGrid;
   },
   _getCpbNameAttr: function() {
      return this._cpbName;
   },
   _getCpbStoreNameAttr: function() {
      return this._cpbStoreName;
   },
   _getDetailsSectionTitleAttr: function() {
      return this.detailsSectionTitle;
   },
   _setDetailsSectionTitleAttr: function(title) {
      this.detailsSectionTitle = title;
      if (this.detailsPanel) {
         this.detailsPanel.set('title', this.detailsSectionTitle);
      }
   },
   _getDetailsPaneHiddenAttr: function() {
      return this.detailsPaneHidden;
   },
   _setDetailsPaneHiddenAttr: function(hidden) {
      if (hidden !== this.detailsPaneHidden) {
         this.detailsPaneHidden = hidden;
         if (hidden) {
            this.removeChild(this.sidePanel);
         }
         else {
            this.addChild(this.sidePanel);
         }
         this.layout();
      }
   },
   _getFormattedCpbNameAttr: function() {
      return CPBGridUtil.getFormattedUINameFromID(this._cpbName);
   },
   _getReadOnlyAttr: function() {
      return this._readOnly;
   },
   _getUIContextIdAttr: function() {
      return this._uiContextId;
   },
   
   _getTitleAttr: function() {
      return this._title;
   },
   _setTitleAttr: function(title) {
      this._title = title;
      if (this.gridTitle) {
         this.gridTitle.innerHTML = '';
         if (title) {
            this.gridTitle.appendChild(document.createTextNode(title));
            domStyle.set(this.gridTitle, 'display', 'block');
         }
         else {
            domStyle.set(this.gridTitle, 'display', 'none');
         }
      }
   },

   // summary:
   //   Allows get('sortStr') to work, so that this component can be used interchangeably with _BaseComponentGrids.
   _getSortStrAttr: function() {
      // Grab the first grid's sort string since that is typically an unfiltered "all" grid.
      return this._childGrids.length > 0 ? this._childGrids[0].get('sortStr') : '';
   }

});

return MultiGrid;

});
