require({cache:{
'url:sas-ecm/components/PrintModeCommentsTemplate.html':"<div>\n</div>\n"}});
/*
 * Prints comments when in print mode (case reports).  This is really a stopgap since CommentManager doesn't
 * support a read-only view, so it was easier to just create an entirely new component (!).
 */
define("sas-ecm/components/PrintModeComments", ['dojo/_base/declare',
         'dijit/_WidgetBase', 'dijit/_TemplatedMixin',
         'sas-cpb/cpb', 'sas-cpb/util/NLSUtil',
         './_PrintModeComment',
         'dojo/i18n!./nls/PrintModeComments',
         'dojo/text!./PrintModeCommentsTemplate.html',
         'dojox/html/entities'
         ],
   function(declare, _WidgetBase, _TemplatedMixin, cpb, NLSUtil,
         _PrintModeComment,
         resources, template, entities) {
   
var PrintModeComments = declare([_WidgetBase, _TemplatedMixin], {
   
   templateString: template,
   
   constructor: function(args) {
      this._labels = args.labels;
   },
   
   postCreate: function() {
      
      this.inherited(arguments);
      
      if (!commentThreads || !commentThreads.length || commentThreads.length===0) {
         var text = document.createTextNode(NLSUtil.resolve('comments_none_found_warning_txt', resources));
         this.domNode.appendChild(text);
         return;
      }
      
      for (var i=0; i<commentThreads.length; i++) {
         var comment = new _PrintModeComment({ title: entities.encode(commentThreads[i].subject), commentInfo: commentThreads[i] });
         comment.placeAt(this.domNode);
      }
      
   }

});

return PrintModeComments;

});