require({cache:{
'url:sas-ecm/efiling/EFileReportsBulkUpdaterTemplate.html':"<div>\n   <div data-dojo-attach-point=\"${titleTarget}\" data-dojo-type=\"dijit/TitlePane\" data-dojo-props=\"closable: 'true', open: 'true', title: '${label}'\">\n      <div data-dojo-attach-point='${gridTarget}'></div>\n      <br />\n      <table width=\"100%\">\n         <tr>\n            <td width=\"5%\">\n               <div data-dojo-attach-point=\"${selectTarget}\"></div>\n            </td>\n            <td>\n               <span data-dojo-attach-point=\"${msgSpan}\" style=\"display: none\">${messageUnselectedWarning}</span>\n            </td>\n         </tr>\n      </table>\n   </div>\n</div>"}});
define(
"sas-ecm/efiling/EFileReportsBulkUpdater", [
      'sas-cpb/cpb', 'dgrid/Grid', 'dgrid/OnDemandGrid', 'dojo/store/Memory', 'dgrid/selector',
      'dgrid/Selection', 'dijit/form/Select', 'dojo/_base/declare', 'dojo/_base/array', 'dojo/_base/lang',
      'dijit/registry', 'dijit/_WidgetBase', 'dijit/_TemplatedMixin', 'dijit/_WidgetsInTemplateMixin',
      'dojo/text!./EFileReportsBulkUpdaterTemplate.html',
      'dojo/i18n!sas-ecm/efiling/nls/EFileReportsBulkUpdater', 
      'dojo/dom', 'dojo/dom-style', 'dojo/aspect', 'dojo/query', 'dijit/form/TextBox'
], function(cpb, Grid, OnDemandGrid, Memory, selector, Selection, Select, declare, array, lang,
      registry, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _template, resources, dom, domStyle, aspect, query, TextBox)
{

   var EFileReportsBulkUpdater = declare('EFileReportsBulkUpdater', [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin],
   {
      name : '',
      label : '',
      
      gridJson : '',
      store : null,
      grid : null,
      gridTarget: '',
      
      selectJson: '',
      select : null,
      selectTarget: '',
      
      templateString: _template,
      messageUnselectedWarning: resources.messageUnselectedWarning,
      
      constructor : function(args)
      {
         lang.mixin(this, args);
         
         this.gridTarget = this.name + '_gridTarget';
         this.selectTarget = this.name + '_selectTarget';
         this.titleTarget = this.name + '_titleTarget';
         this.msgSpan = this.name + '_msgSpan';
         this.store = new Memory({data : this._getArrayDataForGrid()});
         this.closedReports = this.selectJson == '';
         cpb.consoleLog("updater created with name, " + this.name + ", and closedReports == " + this.closedReports);
      },

      postCreate : function()
      {
         this.inherited(arguments);
         
         var updater = this;
                  
         // first build the grid
         this.grid = new (declare([OnDemandGrid, Selection]))(
         {
            id : this.name + '_grid',
            columns : this._getColumns(),
            store: this.store,
            selectionMode : "none",
            allowSelectAll : true,
            noDataMessage : resources.messageNoData,
            loadingMessage : resources.messageLoading
         }, this[this.gridTarget]);
         this.grid.startup();
         
         // There seems to be a bug in dgrid 0.3.6. When clearSelection is called, the checkboxes are still selected, 
         // even though the row loses it's selection styling. This is a fix to work around that. 
         // TODO: Test without this on future version of dgrid.
         // This aspect code doesn't seem to be needed when refresh is called.
//         aspect.after(this.grid, 'clearSelection', function()
//         {
//            query("input[type=checkbox]", this.domNode).forEach(function(node)
//            {
//               cpb.consoleLog("node == " + node);
//               node.checked = false;
//            });
//         });

         if (!this.closedReports)
         {
            // next build the Select
            this.select = new Select(
            {
               id : this.name + '_select',
               options : this.selectJson
            }, this[this.selectTarget]);
            this.select.startup();
            
            // now build all of the hiddens representing the rows in the grid.
            this.gridJson.forEach(function(item)
            {
               var hidden = document.createElement("input");
               hidden.type = "hidden";
               hidden.id = item.hidden_id;
               hidden.name = item.hidden_id;
               hidden.value = "";
               updater.domNode.appendChild(hidden);
            });

            // Add in the event listening.
            updater.grid.on("dgrid-select", function(event)
            {
               // clear the select associated with this grid.
               cpb.consoleLog("clear select for grid, " + updater.grid.id);
               var selection = updater.grid.selection;

               // when selecting new rows, clear the drop-down and hide the warning message.
               updater.select.set('value', '');
               updater._updateMessageSpan(updater, false);
            });
            
            updater.select.on("change", function(event)
            {
               if (updater.select.get('value') != "")
               {
                  var hasSelection = false;
                  var selection = updater.grid.selection;
                  
                  // apply the dropdown value to each selected row.
                  for (var id in selection)
                  {
                     if(selection[id])
                     {
                        hasSelection = true;
                        var rowData = updater.store.get(id);
                        
                        // update the hidden attributes.
                        var hidden_id = rowData['hidden_id_col'];
                        var hidden = dom.byId(hidden_id);
                        if (hidden)
                        {
                           hidden.value = updater.select.get('value');
                        }
                        
                        // update the transition cell in the grid.
                        rowData['transition_col'] = updater.select.value;
                     }
                  }
                  
                  if (hasSelection)
                  {
                     // Refresh the grid to update the transition cells and clear the selected rows.
                     updater.grid.refresh();

                     // Mark the page as dirty
                     if (SaveChangesConfirmation)
                     {
                        SaveChangesConfirmation.setPageDirty();
                     }
                  }
                  else
                  {
                     // show the warning message that nothing was selected.
                     updater._updateMessageSpan(updater, true);
                  }
               }
               else
               {
                  // hide the warning message.
                  updater._updateMessageSpan(updater, false);
               }
            });
         }
      },
      
      _updateMessageSpan : function(updater, show)
      {
         domStyle.set(updater[updater.msgSpan], 'display', show ? 'block' : 'none');
      },

      _getColumns : function()
      {
         var columns = [];

         if (!this.closedReports)
         {
            columns.push(selector(
            {
               field : 'checkboxes',
               resizable : false,
               unhidable : true
            }));
         }
         columns.push(
         {
            label : resources.headerReportID,
            field : 'report_id_col',
            resizable : false,
            unhidable : true,
            sortable : false
         });
         columns.push(
         {
            label : resources.headerCreatedByUser,
            field : 'user_id_col',
            resizable : false,
            unhidable : true,
            sortable : false, 
            renderCell: sas_userNameRenderer_user_id
         });
         if (this.closedReports)
         {
            columns.push(
            {
               label : resources.headerStatus,
               field : 'status_col',
               resizable : false,
               unhidable : true,
               sortable : false,
               renderCell: sas_refTableRenderer_RT_RR_STATUS
            });
         }
         else
         {
            columns.push(
            {
               label : resources.headerTransition,
               field : 'transition_col',
               resizable : false,
               unhidable : true,
               sortable : false, 
               renderCell: function(rowData, data, node, options) { 
                  var div = document.createElement('div'); 
                  div.setAttribute('id', 'transition_div');
                  
                  var text = document.createTextNode(data); 
                  div.appendChild(text);
                  node.appendChild(div); 
               }
            });
         }
         columns.push({
            label : resources.headerDCN,
            field : 'dcn_col',
            resizable : false,
            unhidable : true,
            sortable : false, 
            renderCell: function(rowData, data, node, options) {
               var text = registry.byId(data.id);
               if (text) {
                  data.value = text.get('value');
                  text.destroyRecursive();
               }
               text = new TextBox({
                  id : data.id,
                  name : data.name,
                  value : data.value ? data.value : ''/*,
                  title : data.title,
                  style : 'width: 100%; -webkit-box-sizing: border-box; -moz-box-sizing: border-box; box-sizing: border-box;'
                  */
               });
               text.on('keyup', function() {
                  EFileReportsGrid.markDCNDirty(document.forms['EFilingForm'], data.id);
               });
               node.appendChild(text.domNode);
            }
         });
         return columns;
      },

      _getArrayDataForGrid : function()
      {
         var rowCount = 0;
         var data = [];
         this.gridJson.forEach(function(item)
         {
            data.push(
            {
               id : this.name + '_' + rowCount++,
               report_id_col : item.report_id,
               user_id_col : item.user_id,
               status_col : item.status_cd,
               transition_col : item.transition,
               hidden_id_col : item.hidden_id,
               dcn_col : item.dcn
            });
         });

         return data;
      }

   });

   return EFileReportsBulkUpdater;

});
