<%-- Copyright (c) 2003-2008 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="/shell/default.jspf"%>
<%@page errorPage="pageError.jsp" %>
<%@taglib prefix="sas-cm" uri="http://www.sas.com/casemgmt/tag" %>
<%@page import="com.sas.solutions.casemgmt.service.ServiceLocator"%>
<%@page import="com.sas.solutions.casemgmt.web.util.WebUtil"%>
<sas-ui:DocType/>

<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en-US' dir='<%=WebUtil.getDirAttributeValue(request)%>'>
<head>
   <meta http-equiv="X-UA-Compatible" content="IE=edge" />
   <title><sas-ui:ApplicationName/></title>
   <% com.sas.servlet.util.JavaScriptIncludeHandler.clear(request); %>
   <%@ include file="global.jspf" %>
   <script type="text/javascript">
	   // needed to turn on the context menu on right mouse click.
	   var enableContextMenu = true;
   </script>
   
   
   <%@include file="/dojo_config.jspf"%>
   
   <sas-cm:include js="/shared/app.js" />
   <sas-cm:include js="/shared/ecmApi.js" />
   <sas-cm:include js="/ext/cpbcore/bgoverlay/BackgroundOverlay.js" />
   <sas-cm:include js="/ext/cpbcore/browser/Event.js" />
   <sas-cm:include js="/ext/cpbcore/browser/BrowserUtil.js" />
   <sas-cm:include js="/ext/cpbcore/browser/URL.js" />
   <sas-cm:include js="/ext/cpbcore/browser/QueryString.js" />
   
   <sas-cm:include flush="true" />
   
   <script type="text/javascript">
   require(['sas-cpb/cpb'], function(cpb) {
      cpb.showLog = <%=ServiceLocator.isDevelopmentMode()%>;
   });
   // initialize the window name based on the window layout
   App.initWindowName('<%=WindowLayout.MODAL_DIALOG.toString()%>');
   </script>
   
   <!-- Temporary styles to override corporate stuff that looks bad, until
        we are 100% dojo-ified -->
   <style type="text/css">
   #popupButtonBarContainer {
      position: fixed;
      bottom: 0px;
      width: 100%;
   }
   </style>
</head>
<body dir="<%=WebUtil.getDirAttributeValue(request)%>" class="<%=ThemeUtil.getDojoTheme(request)%>"
      onload="if (window.opener && window.opener.sas_framework_updateTimeout) window.opener.sas_framework_updateTimeout();">

<div data-dojo-type='dijit/layout/BorderContainer' id='mainBorderContainer' data-dojo-props="gutters: false, style: 'width: 100%; height: 100%'">

<div data-dojo-type='dijit/layout/ContentPane' data-dojo-props='region: "top"'>
   <div id='mainToolBar' style='display: none'></div>
</div>

<div data-dojo-type='dijit/layout/ContentPane' data-dojo-props='region: "center"'>
   <tiles:insert page="<%=(String)request.getAttribute(WebKey.CONTENT_FILE)%>"/>
</div>

<script type='text/javascript'>
require(['dijit/registry', 'dijit/layout/ContentPane', 'sas-cpb/util/ButtonUtil', 'sas-cpb/cpb', 'dojo/ready'],
      function(registry, ContentPane, ButtonUtil, cpb, ready) {
   ready(function() {
   <%
      String buttonJson = (String)request.getAttribute("submitBarJson");
      if (buttonJson!=null) {
   %>
      window.modalSubmitBarModel = <%=buttonJson%>;
   <% } %>
      if (window.modalSubmitBarModel) {
         var buttonPane = new ContentPane({
            id: 'modalButtonsDiv',
            region: 'bottom',
            class: 'dijitDialogPaneActionBar'
         });
         buttonPane.placeAt('mainBorderContainer');
         ButtonUtil.writeButtonBar(modalSubmitBarModel, 'modalButtonsDiv');
         registry.byId('mainBorderContainer').layout();
      }
      // Our modals typically contain iframes.  Make sure we focus the first form field after it loads
      if (document.location.toString().indexOf('#') === -1) {
         setTimeout(function() {
            cpb.setFocus();
         }, 0);
      }
      <%-- When the Dialog itself is set to a fixed height like "450px", the center
           region is being set to the same height, causing part of it to underlay
           the button bar. Scale the center region's height down to 90%, which should
           still leave plenty of room for the 33px button bar, even when the dialog
           is as small as 450px. --%>
      document.querySelector("[data-dojo-props='region: \"center\"']").style.height="90%";
   });
});
</script>

</div>

</body>
</html>
