<%-- Copyright (c) 2003-2008 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@page import="com.sas.solutions.cpb.web.util.CPBUtil"%>
<%@include file="/shell/default.jspf"%>
<%@page errorPage="pageError.jsp" %>
<%@taglib uri='http://www.sas.com/taglib/sas-util' prefix='sas-u' %>

<%@page import="com.sas.solutions.casemgmt.i18n.AppProperties" %>
<%@page import="com.sas.solutions.casemgmt.service.ServiceLocator"%>
<%@page import="com.sas.solutions.casemgmt.util.SecurityUtil" %>
<%@page import="com.sas.solutions.casemgmt.web.util.WebUtil" %>

<sas-ui:DocType/>
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en-US' dir='<%=WebUtil.getDirAttributeValue(request)%>'>
<head>
   <meta http-equiv="X-UA-Compatible" content="IE=edge" />
   <title><sas-ui:ApplicationName/></title>
   <% com.sas.servlet.util.JavaScriptIncludeHandler.clear(request); %>
   <%@ include file="global.jspf" %>
   
   <%@include file="/dojo_config.jspf"%>
   
   <script type="text/javascript">
	   // needed to turn on the context menu on right mouse click.
      var enableContextMenu = true;
   </script>
   
   <sas-cm:include js="/shared/app.js" />
   <sas-cm:include js="/shared/ecmApi.js" />
   <sas-cm:include js="/ext/cpbcore/browser/Event.js" />
   <sas-cm:include flush="true" />
   
   <script type="text/javascript">
   require(['sas-cpb/cpb'], function(cpb) {
      cpb.showLog = <%=ServiceLocator.isDevelopmentMode()%>;
   });
   </script>
   
   <script type="text/javascript">
   require(['dojo/ready', 'sas-cpb/messages/Messages'], function(ready, Messages) {
      ready(function() {
         var msgs = new Messages({infos: [ '<%=AppProperties.getProperty("optimize.print.message.txt")%>' ] });
         msgs.showMessages();
      });
   });
   </script>
   <style>
      @media screen
      {
         body 
         {
            overflow: auto;
         }
      }
      @media print
      {
         body
         {
            overflow: visible !important;
         }
      }
   </style>
</head>
<body dir="<%=WebUtil.getDirAttributeValue(request)%>" style="margin: 0; padding: 0;" class="<%=ThemeUtil.getDojoTheme(request)%>">

<div id='bodyArea'>
<%
String title = CPBUtil.getPageTitle(request) == null ? "" : CPBUtil.getPageTitle(request);
%>
   <div id="caseReport_errors" class="caseReport-errors"></div>
   <h1 id="h1_pageTitle_id"><%=title%></h1>
   
   <!-- Main Content -->
   <tiles:insert page="<%=(String)request.getAttribute(WebKey.CONTENT_FILE)%>"/>
   <%@include file="/ext/cpbcore/messages/ShowMessages.jsp" %>

   <%-- When displaying case reports, make sure error messages are prominently displayed at the top of the page. --%>
   <script>
   if (window.errors) {
      var errorDiv = document.getElementById('caseReport_errors');
      window.errors.forEach(function(error) {
         errorDiv.appendChild(document.createTextNode(error));
         errorDiv.appendChild(document.createElement('br'));
      });
   }
   </script>
</div>
</body>
</html>
